'======================================
' CODICI    -  Check Italian Codice Fiscale e Partita IVA
'              v. 1.0  -  1995/06/06
'--------------------------------------
'Functions
' CheckCodiceFiscale(sz_Codice)
' CheckPartitaIVA(sz_Codice)
'--------------------------------------
' For every comment/suggestion, feel free to
' contact me at 100265,1725@CompuServe.com
'--------------------------------------
' For other source code (and shareware programs <g>)
' check for the TCI-SS keyword in Cis:Italfor Section 17
'======================================


Function CheckCodiceFiscale (ByVal sz_Codice As String) As Integer
    '===== Returns
    '      0 = the input string is a correct fiscal code
    '      or the ascii of correct check-code (65=A)
    '
    Const ALF1 = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    Const CIF1 = "0123456789"
    Const ALF2 = "BAKPLCQDREVOSFTGUHMINJWZYX"
    Const CIF2 = "10   2 3 4   5 6 7 8 9    "
    Dim c_Char As String * 1
    Dim c_Code As String * 1
    Dim n_Count As Integer
    Dim lcv As Integer
    '----- Start
    sz_Codice = Left(UCase(sz_Codice) + Space(16), 16)
    For lcv = 2 To 14 Step 2
        c_Char = Mid$(sz_Codice, lcv, 1)
        Select Case c_Char
            Case "0" To "9"
                n_Count = n_Count + InStr(CIF1, c_Char)
            Case "A" To "Z"
                n_Count = n_Count + InStr(ALF1, c_Char)
        End Select
    Next lcv
    For lcv = 1 To 15 Step 2
        c_Char = Mid$(sz_Codice, lcv, 1)
        Select Case c_Char
            Case "0" To "9"
                n_Count = n_Count + InStr(CIF2, c_Char)
            Case "A" To "Z"
                n_Count = n_Count + InStr(ALF2$, c_Char)
        End Select
    Next lcv
    n_Count = 1 + ((n_Count - 15) Mod 26) + 64
    c_Code = Chr$(n_Count)
    c_Char = Mid$(sz_Codice, 16, 1)
    If c_Code = c_Char Then
        CheckCodiceFiscale = 0
    Else
        CheckCodiceFiscale = n_Count
    End If
End Function

Function CheckPartitaIva (ByVal sz_Codice As String) As Integer
    '===== Returns
    '      0 = the input string is a correct IVA code
    '      or the ascii of correct check-code (65=A)
    Dim n_Val  As Integer
    Dim n_Som1 As Integer
    Dim n_Som2 As Integer
    Dim lcv    As Integer
    '----- Start
    For lcv = 1 To 9 Step 2
        n_Val = Val(Mid$(sz_Codice, lcv, 1))
        n_Som1 = n_Som1 + n_Val
        n_Val = Val(Mid$(sz_Codice, lcv + 1, 1))
        n_Som1 = n_Som1 + Int((n_Val * 2) / 10) + ((n_Val * 2) Mod 10)
    Next lcv
    n_Som2 = 10 - (n_Som1 Mod 10)
    n_Val = Val(Mid$(sz_Codice, 11, 1))
    If n_Som2 = n_Val Then
        CheckPartitaIva = 0
    Else
        CheckPartitaIva = n_Som2 + 48
    End If
End Function

